<template>
  <div class="container rooms-page">
    <breadcrumbs class="rooms-page__breadcrumbs" v-if="!isMobileSSR"></breadcrumbs>

    <h1 class="page-title rooms-page__title">Помещения</h1>

    <div class="rooms-page__top">
      <div class="rooms-page__filters"
           v-if="!isMobileSSR || isFiltersOpen">

        <div class="rooms-page__filter"
             v-for="filter in filters" :key="filter.name">

          <range-dropdown v-if="filter.dropdownType === 'range'"
                          :filter="filter"
                          @clearValue="filter.value = []"
          />

          <check-dropdown v-if="filter.dropdownType === 'check'"
                          :filter="filter"
                          @clearValue="filter.activeItems = []"
                          @setActiveItems="filter.activeItems = $event"
          />

          <date-dropdown v-if="filter.dropdownType === 'date'"
                         :filter="filter"
                         @clearValue="filter.selectedDate = null"
                         @setActiveDates="filter.selectedDate = $event"
          />

        </div>

      </div>

      <span class="rooms-page__filters-label"
            :class="{ 'active': isFiltersOpen }"
            v-if="isMobileSSR"
            @click="toggleFilters">
          <icon-filter />
          Фильтры
        </span>

      <sorting class="rooms-page__sorting"
               :sortingType="sortingType"
               @changeSortingType="sortingType = $event"
      />
    </div>

    <rooms-list class="rooms-page__rooms"
                v-if="rooms.length"
                :rooms="rooms"
                ref="roomsList"
    />

    <span v-else
          class="rooms-page__no-found">
      Ничего не найдено
    </span>

    <pagination
      v-if="roomsTotal > roomsPerPage"
      class="rooms-page__pagination"
      v-model.number="currentPage"
      @input="onChangePage"
      :total="roomsTotal"
      :per-page="roomsPerPage"
    />

    <pre-footer class="rooms-page__pre-footer"
                v-if="meta.content"
                :content="meta.content"/>
  </div>
</template>

<script>
  import { mapActions } from 'vuex';
  import _ from 'lodash';

  import PreFooter from '../../components/PreFooter';
  import Breadcrumbs from '../../components/Breadcrumbs';
  import Sorting from '../../components/Sorting';
  import Dropdown from '../../components/dropdown/Dropdown';
  import RangeWithInputs from '../../components/RangeWithInputs';
  import RangeDropdown from '../../components/dropdown/RangeDropdown';
  import CheckDropdown from '../../components/dropdown/CheckDropdown';
  import RoomsList from '../../components/RoomsList';
  import Pagination from '../../components/Pagination';
  import DateDropdown from '../../components/dropdown/DateDropdown';
  import IconFilter from '../../components/icons/IconFilter';

  import getFiltredFilters from '../../assets/js/helpers/get-filtred-filters';
  import getURLFilterQuery from '../../assets/js/helpers/get-url-filter-query';

  import { getRooms, getSeoBySlug } from '../../service/deliroom-service';

  const filtersTemplate = [
    {
      dropdownType: 'date',
      type: 'date',
      selectedDate: null
    },
    {
      dropdownType: 'range',
      type: 'time',
      label: '',
      value: [],
      values: [9, 22],
      flags: ['Утро', 'Вечер'],
    },
    {
      dropdownType: 'range',
      type: 'area',
      name: 'Площадь',
      label: 'м<sup>2</sup>',
      value: [],
    },
    {
      dropdownType: 'range',
      type: 'capacity',
      label: 'чел.',
      value: []
    },
    {
      dropdownType: 'range',
      type: 'price',
      label: '₽',
      value: []
    },
    {
      dropdownType: 'check',
      type: 'metro_station',
      shortName: 'Метро',
      activeItems: [],
    },
    {
      dropdownType: 'check',
      type: 'type',
      shortName: 'Тип',
      activeItems: [],
    },
  ];

  function getParams(typeParams, query, filters, sortingType, currentPage) {
    const params = {};

    if (Object.keys(query).length || typeParams) {
      filters.forEach((filter) => {
        switch (filter.dropdownType) {
          case 'date':
            if (filter.selectedDate === null) return;

            const currentHours = new Date().getHours();
            const tmp = filter.selectedDate.setHours(currentHours - (filter.selectedDate.getTimezoneOffset() / 60) + 1, 0, 0);

            params[filter.type] = new Date(tmp).toISOString();

            break;

          case 'check':
            if (!filter.activeItems.length) return;

            filter.activeItems.forEach((activeItem, index) => {
              params[`${filter.type}[${index}]`] = activeItem.id
            });

            break;

          case 'range':
            if (!filter.value.length) return;

            if (filter.type === 'time') {
              params[`${filter.type}[min]`] = parseInt(filter.value[0]);
              params[`${filter.type}[max]`] = parseInt(filter.value[1]);
            } else {
              params[`${filter.type}[min]`] = filter.value[0];
              params[`${filter.type}[max]`] = filter.value[1];
            }

            break;
        }
      });

      params.order_field = 'price'; // В поле для сортировки пока всегда отдаем цену
      params.order_dir = sortingType || 'asc';
      params.page = currentPage;
    } else {
      if (typeof window !== 'undefined' && window.innerWidth < 500) {
        params.page = currentPage;
      }

      filters.forEach((filter) => {
        switch (filter.dropdownType) {
          case 'date':
            filter.selectedDate = null;

            break;

          case 'check':
            filter.activeItems = [];

            break;

          case 'range':
            filter.value = [];

            break;
        }
      });
    }

    return params;
  }

  export default {
    name: 'index',
    components: {
      IconFilter,
      DateDropdown,
      Pagination,
      RoomsList,
      CheckDropdown,
      RangeDropdown,
      PreFooter,
      Breadcrumbs,
      Sorting,
      Dropdown,
      RangeWithInputs
    },
    data: () => ({
      isFiltersOpen: false,
      canAddMobileRooms: true,
    }),

    asyncData: async (context) => {
      let isMobile = null;

      if (context.req) {
        isMobile = /Mobile|webOS|BlackBerry|IEMobile|MeeGo|mini|Fennec|Windows Phone|Android|iP(ad|od|hone)/i.test(context.req.headers['user-agent'])
      } else {
        isMobile = context.store.state.isMobile
      }

      if (!context.store.state.filters.filters.length) {
        await context.store.dispatch('filters/getFilters');
      }

      const filters = getFiltredFilters(context.store.state.filters.filters, filtersTemplate);
      let sortingType = '';
      let currentPage = 1;

      if (context.query.type && context.query.type.match(/^\d+$/)) {
        const filter = context.store.state.filters.filters.find(f => f.type === 'type')
        const neededType = filter.values.find(t => +context.query.type === +t.id)
        if (neededType) {
          let query = {...context.query}
          delete query['type']

          context.redirect(301, `/places/${neededType.code}`, query)
        }
      }

      Object.entries(context.query).forEach(([key, value]) => {
        const neededFilter = filters.filter((filter) => filter.type === key)[0];

        if (neededFilter) {
          switch (neededFilter.dropdownType) {
            case 'date':
              const needToSelectDate = new Date(Number(value * (1000 * 3600)));

              neededFilter.selectedDate = needToSelectDate;

              break;

            case 'check':
              const needToSelectIds = value.split(',');
              const neededValues = neededFilter.values.filter((value) => needToSelectIds.includes(String(value.id)));

              neededFilter.activeItems = [...neededValues];

              break;

            case 'range':
              const needToSelectData = value.substr(1, value.length - 2).split(',');

              neededFilter.value = [...needToSelectData];

              break;
          }

          return;
        }

        if (key === 'sort') {
          sortingType = value;
        }

        if (!isMobile && key === 'page') {
          currentPage = value;
        }
      });

      if (context.params.id) {
        const neededFilter = filters.filter((filter) => filter.type === 'type')[0];
        const neededValues = neededFilter.values.filter((value) => value.code === context.params.id);

        if (!neededValues.length) {
          context.redirect('/404')
          return;
        }

        neededFilter.activeItems = [...neededValues]
      }

      const params = getParams(context.params, context.query, filters, sortingType, currentPage);

      const roomsResponse = await getRooms(params);

      return {
        meta: context.params.id ? await getSeoBySlug(`/places/${context.params.id}`) || await getSeoBySlug('/places') : await getSeoBySlug('/places'),

        filters: filters,
        sortingType: sortingType,
        isFiltersOpen: false,

        rooms: roomsResponse.data,
        roomsPerPage: Number(roomsResponse.meta.per_page),
        currentPage: Number(roomsResponse.meta.current_page),
        roomsTotal: Number(roomsResponse.meta.total),

        isMobileSSR: isMobile
      }
    },

    async mounted() {
      if (this.isMobile || this.isMobileSSR) {
        window.addEventListener('scroll', _.debounce(() => {
          if (!this.isMobile) return;
          if (!this.$refs.roomsList) return;

          const rommsListCoords = this.$refs.roomsList.$el.getBoundingClientRect();

          if (rommsListCoords.height < Math.abs(rommsListCoords.top - window.innerHeight)) {

            if (this.canAddMobileRooms && (this.rooms.length < this.roomsTotal)) {
              this.currentPage++;
              this.canAddMobileRooms = false;

              this.getFiltredRooms({ onScroll: true });
            }

          }
        }));
      }
    },

    computed: {
      isMobile() {
        return this.$store.state.isMobile;
      },
    },

    watch: {
      isMobile(val) {
        this.isMobileSSR = val;
      },

      filters: {
        deep: true,

        handler() {
          this.currentPage = 1;

          this.$router.push({
            name: 'places',
            query: getURLFilterQuery(this.filters, this.sortingType, this.currentPage)
          })
        }
      },

      sortingType(val) {
        this.currentPage = 1;

        this.$router.push({
          path: 'places',
          query: getURLFilterQuery(this.filters, val, this.currentPage)
        })
      },

      $route: {
        async handler(val) {
          if (!val.query.sort) this.sortingType = '';

          if (val.query.type && val.query.type.split(',').length === 1) {
            const filter = this.$store.state.filters.filters.find(f => f.type === 'type')
            const neededType = filter.values.find(t => +val.query.type === +t.id)
            if (neededType) {
              let query = {...val.query}
              delete query['type']

              this.$router.push({name: 'places-rtype', params: {id: neededType.code}, query})
            }
          }

          await this.getFiltredRooms();
        }
      }
    },

    methods: {
      ...mapActions({
        getFilters: 'filters/getFilters'
      }),

      onChangePage() {
        window.scrollTo({top: 0, behavior: 'smooth'});

        setTimeout(() => {
          this.$router.push({
            path: 'places',
            query: getURLFilterQuery(this.filters, this.sortingType, this.currentPage)
          });
        }, 350);
      },

      toggleFilters() {
        this.isFiltersOpen = !this.isFiltersOpen;
      },

      async getFiltredRooms(options = {}) {
        const params = getParams(this.$route.params, this.$route.query, this.filters, this.sortingType, this.currentPage);
        const roomsResponse = await getRooms(params);

        if (roomsResponse.errors && Object.keys(roomsResponse.errors).length) {

          this.rooms = [];
          this.roomsPerPage = null;
          this.currentPage = 1;
          this.roomsTotal = null;
        } else {

          if (options.onScroll) {
            this.rooms.push(...roomsResponse.data);

            this.$nextTick(() => this.canAddMobileRooms = true);
          } else {
            this.rooms = roomsResponse.data;
          }

          this.roomsPerPage = roomsResponse.meta.per_page;
          this.currentPage = roomsResponse.meta.current_page;
          this.roomsTotal = roomsResponse.meta.total;
        }
      }
    },

    head() {
      if (!this.meta) return;

      return {
        title: this.meta.title,
        meta: this.meta.meta.map((metaItem) => ({
          ...metaItem,
          hid: metaItem.name.toLowerCase(),
          name: metaItem.name.toLowerCase(),
        })),
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .rooms-page {
    & .rooms-page__breadcrumbs {
      margin-bottom: rem(10);

      @media (max-width: $mobile-width) {
        display: none;
      }
    }

    &__title {
      margin-bottom: rem(40);

      @media (max-width: $mobile-width) {
        display: none;
      }
    }

    &__top {
      display: flex;
      align-items: baseline;
      justify-content: space-between;

      @media (max-width: $mobile-width) {
        flex-flow: wrap;
        align-items: flex-start;
        margin-top: rem(30);
        margin-bottom: rem(36);
      }
    }

    &__filters {
      display: flex;
      flex-flow: wrap;

      margin: rem(-8);

      @media (max-width: $mobile-width) {
        order: 1;
        flex: 0 0 100%;
        width: 100%;
        margin-top: rem(16);
      }
    }

    &__filter {
      margin: rem(8);
    }

    &__filters-label {
      display: none;

      @media (max-width: $mobile-width) {
        @include bold-black-link;

        display: flex;
        align-items: center;

        svg {
          margin-right: rem(4);
        }

        &.active {
          color: $green;

          svg path {
            fill: $green;
          }
        }
      }
    }

    &__sorting {
      flex: 0 0;
      margin-left: rem(24);
    }

    &__no-found {
      @include p1;

      display: block;
      margin-top: rem(32);
    }

    // Для переопределения стилей внутри компонентов
    & .rooms-page {
      &__rooms.rooms-list {
        margin-top: rem(15);
        margin-bottom: rem(25);

        @media (max-width: $mobile-width) {
          margin-top: rem(-18);
          margin-bottom: rem(-18);
        }
      }

      &__pre-footer {
        margin-top: rem(90);
      }

      &__pagination {
        @media (max-width: $mobile-width) {
          display: none;
        }
      }
    }
  }


</style>
